<template>
  <q-page padding>
    <div v-if="planet">
      <q-toolbar style="height: 60px;">
        <q-btn
          to="/planets"
          icon="arrow_back"
          color="secondary"
          unelevated
          flat
          round
        />
        <q-separator vertical class="q-mx-sm" inset />
        <q-toolbar-title class="text-secondary">
          <div>{{ planet.name }}</div>
        </q-toolbar-title>
        <q-btn
          label="Edit"
          @click="editNotify"
          icon="edit"
          color="secondary"
          unelevated
        />
      </q-toolbar>
      <div class="q-py-md">
        <div class="q-mt-lg">
          <q-banner class="bg-secondary text-white" rounded>
            <div class="text-bold">Other detail params</div>
            <div class="q-pt-md">{{ planet }}</div>
          </q-banner>
        </div>
      </div>
    </div>
    <q-inner-loading :showing="loading">
      <q-spinner-puff size="50px" color="primary" />
    </q-inner-loading>
  </q-page>
</template>

<style></style>

<script>
import { mapState } from 'vuex'

export default {
  name: 'PlanetPage',
  computed: {
    ...mapState('planets', {
      // same as state >> state.pokemonDetail.data || null
      // optional chaining >> state?.pokemonDetail?.data ?? null
      planet: ({ planetDetail: { data } }) => data,
      loading: ({ planetDetail: { loading } }) => loading,
      error: ({ planetDetail: { error } }) => error,
    }),
  },
  methods: {
    editNotify() {
      this.$q.notify({
        message: "Upssssi. You can't edit.",
        color: 'negative',
        position: 'top',
      })
    },
  },
  mounted() {
    this.$store.dispatch('planets/getPlanetDetail', {
      id: this.$route.params.id,
    })
  },
}
</script>
